// Sample6Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample6.h"
#include "Sample6Dlg.h"
#include "winspool.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSample6Dlg dialog

CSample6Dlg::CSample6Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample6Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample6Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSample6Dlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDPRINT, &CSample6Dlg::OnBnClickedPrint)
END_MESSAGE_MAP()


// CSample6Dlg message handlers

BOOL CSample6Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample6Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample6Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSample6Dlg::OnBnClickedPrint()
{
HDC hdc;
DOCINFO docinfo; 
TEXTMETRIC textmetric;
int wk;
HFONT hFont,hBeforeFont;
CHAR DriverName[] = "NPI Integration Driver";	//ドライバ名

HANDLE hPrn;
DEVMODE        *devmode;
unsigned char* buff_dev = NULL;
LONG  devSize;


	memset(&docinfo, 0, sizeof(DOCINFO));
	docinfo.cbSize = sizeof(DOCINFO);
	docinfo.lpszDocName = "testprint"; 

	//!!注意!! CreateDCの引数は各環境で異なります 
	hdc = CreateDC(DriverName, DriverName, NULL, NULL);
    if(OpenPrinter(DriverName, &hPrn, NULL) )
    {
        //DEVMODE構造体 サイズ取得＆領域生成
        devSize  = DocumentProperties(NULL, hPrn, NULL, NULL, NULL, 0);
        buff_dev = new unsigned char[devSize];
        devmode  = (DEVMODE*)buff_dev;
        //情報取得
        DocumentProperties(NULL,
                           hPrn,
                           NULL,
                           devmode,
                           NULL,
                           DM_IN_BUFFER | DM_OUT_BUFFER);
	}
	ClosePrinter(hPrn);

	StartDoc(hdc, &docinfo);	
	//印刷の向きを横に
	devmode->dmOrientation = DMORIENT_LANDSCAPE;

	//変更したDevModeでデバイスコンテキストを再設定
	ResetDC(hdc,devmode);
	//領域開放
	if(buff_dev != NULL)
		delete[] buff_dev;

	StartPage(hdc);
	hFont = CreateFont(40, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0,
            SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
            DEFAULT_QUALITY, DEFAULT_PITCH, "Century");
    hBeforeFont = (HFONT)SelectObject(hdc, hFont);
	GetTextMetrics(hdc, &textmetric);
	TextOut(hdc, 10, textmetric.tmHeight * 1, "Gift certificate", 16);
	TextOut(hdc, 10, textmetric.tmHeight * 2, 
		"----------------------------------------", 40);

	wk = textmetric.tmHeight *4;
	wk+= textmetric.tmHeight;
	TextOut(hdc, 260, wk+= textmetric.tmHeight, "        \\2,000-", 15);
	TextOut(hdc, 260, wk+= textmetric.tmHeight, "---------------", 15);

	wk+= textmetric.tmHeight;
	wk+= textmetric.tmHeight;
	wk+= textmetric.tmHeight;
	wk+= textmetric.tmHeight;
	TextOut(hdc, 250, wk+= textmetric.tmHeight, "Expiration date:2010/09/30", 26);
	TextOut(hdc, 250, wk+= textmetric.tmHeight, "ABC shop", 8);
	
	SelectObject(hdc, hBeforeFont);
	EndPage(hdc);
	EndDoc(hdc);
	DeleteDC(hdc);
}
